﻿using FluentNHibernate;
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;
using TravelCompanyClientApp.Models;
using TravelCompanyContracts.BindingModels.TouristBindingModels;
using TravelCompanyContracts.ViewModels.TouristViewModels;

namespace TravelCompanyClientApp.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }
        [HttpGet]
        public IActionResult Index()
        {
            if (APIClient.Tourist == null)
            {
                return Redirect("~/Home/Enter");
            }
            return View(APIClient.GetRequest<List<TravelViewModel>>($"api/travel/gettravels?touristId={APIClient.Tourist.Id}"));
        }

            [HttpGet]
        public IActionResult Privacy()
        {
            if (APIClient.Tourist == null)
            {
                return Redirect("~/Home/Enter");
            }
            return View(APIClient.Tourist);
        }
        [HttpPost]
        public void Privacy(string login, string email, string password, string surname, string name, string patronymic, string birthday)
        {
            if (APIClient.Tourist == null)
            {
                throw new Exception("Вы как суда попали? Суда вход только авторизованным");
            }
            //доделать проверку
            if (string.IsNullOrEmpty(login) || string.IsNullOrEmpty(password))
            {
                throw new Exception("Введите логин, пароль и ФИО");
            }
            APIClient.PostRequest("api/tourist/updatedata", new TouristBindingModel
            {
                Id = APIClient.Tourist.Id,
                Surname=surname,
                Name=name,
                Patronymic=patronymic,
                BirthDay= DateTime.Parse(birthday),
                Login = login,
                Email = login,
                Password = password
            });

            APIClient.Tourist.Surname = surname;
            APIClient.Tourist.Name = name;
            APIClient.Tourist.Patronymic = patronymic;
            APIClient.Tourist.BirthDay = DateTime.Parse(birthday);
            APIClient.Tourist.Login = login;
            APIClient.Tourist.Email = email;
            APIClient.Tourist.Password = password;
            Response.Redirect("Privacy");
        }
        //к
        public IActionResult Excursion()
        {
            if (APIClient.Tourist == null)
            {
                return Redirect("~/Home/Enter");
            }
            return View(APIClient.GetRequest<List<ExcursionViewModel>>($"api/excursion/getexcursions?touristId={APIClient.Tourist.Id}"));
        }
        [HttpGet]
        public IActionResult CreateExcursion()
        {
            return View();
        }

        [HttpPost]
        public void CreateExcursion(string excursionname, string description, int duration)
        {
            //if (string.IsNullOrEmpty(name) || string.IsNullOrEmpty(password))
            //{
            //    throw new Exception("Введите логин, пароль и ФИО");
            //}
            APIClient.PostRequest("api/excursion/createexcursion", new ExcursionBindingModel
            {
                ExcursionName = excursionname,
                ExcursionDescrition = description,
                Duration = duration,
                TouristId = APIClient.Tourist.Id
            });
            Response.Redirect("Excursion");
            return;
        }
        [HttpGet("/home/updateexcursion/{id?}")]
        public IActionResult UpdateExcursion(int id)
        {
            if (APIClient.Tourist == null)
            {
                return Redirect("~/Home/Enter");
            }
            return View(APIClient.GetRequest<ExcursionViewModel>($"api/excursion/getexcursion?touristId={APIClient.Tourist.Id}&id={id}"));
        }
        [HttpPost("/home/updateexcursion/{id?}")]
        public void UpdateExcursion(int id, string name, string description, int duration)
        {
            if (APIClient.Tourist == null)
            {
                throw new Exception("Доступно только авторизованным пользователям");
            }
            //if (string.IsNullOrEmpty(name) || string.IsNullOrEmpty(password))
            //{
            //    throw new Exception("Введите логин, пароль и ФИО");
            //}
           APIClient.PostRequest("api/excursion/updateexcursion", new ExcursionBindingModel
            {
                Id = id,
                ExcursionName = name,
                ExcursionDescrition = description,
                Duration = duration,
                TouristId = APIClient.Tourist.Id
            });
            Response.Redirect("/Home/Excursion");
            return;
        }
        

        [HttpPost("/home/deleteexcursion/{id?}")]
        public void DeleteExcursion(int id)
        {
            
                if (APIClient.Tourist == null)
                {
                    throw new Exception("Вы как сюда попали? Сюда вход только авторизованным");
                }

            APIClient.PostRequest($"api/excursion/deleteexcursion", new ExcursionBindingModel { Id = id });
            Response.Redirect("/Home/Excursion");
        }
        

        public IActionResult Place()
        {
            if (APIClient.Tourist == null)
            {
                return Redirect("~/Home/Enter");
            }
            return View(APIClient.GetRequest<List<PlaceViewModel>>($"api/place/getplaces?touristId={APIClient.Tourist.Id}"));
        }

        [HttpGet]
        public IActionResult Enter()
        {
            return View();
        }

        [HttpPost]
        public void Enter(string login, string password)
        {
            if (string.IsNullOrEmpty(login) || string.IsNullOrEmpty(password))
            {
                throw new Exception("Введите логин и пароль");
            }
            APIClient.Tourist = APIClient.GetRequest<TouristViewModel>($"api/tourist/login?login={login}&password={password}");
            if (APIClient.Tourist == null)
            {
                throw new Exception("Неверный логин/пароль");
            }
            Response.Redirect("Privacy");
        }

        public IActionResult Report()
        {
            return View();
        }
        [HttpGet]
        public IActionResult Register()
        {
            return View();
        }

        [HttpPost]
        public void Register(string login, string email, string password, string surname, string name, string patronymic, string birthday)
        {
            if (string.IsNullOrEmpty(login) || string.IsNullOrEmpty(password) )
            {
                throw new Exception("Введите логин, пароль и ФИО");
            }
            APIClient.PostRequest("api/tourist/register", new TouristBindingModel
            {
                Login = login,
                Email = email,
                Password = password,
                Surname = surname,
                Name = name,
                Patronymic = patronymic,
                BirthDay = DateTime.Parse(birthday)
            });
            Response.Redirect("Enter");
            return;
        }
       








        /*[HttpPost]
        public void CreateTravel(string travelname, string datestart, string traveldesc, List<int> tours)
        {
            if (APIClient.Client == null)
            {
                throw new Exception("Вы как суда попали? Суда вход только авторизованным");
            }
            if (count <= 0)
            {
                throw new Exception("Количество и сумма должны быть больше 0");
            }
            APIClient.PostRequest("api/main/createorder", new OrderBindingModel
            {
                ClientId = APIClient.Client.Id,
                ReinforcedId = Reinforced,
                Count = count,
                Sum = Calc(count, Reinforced)
            });
            Response.Redirect("Index");
        }
        */
        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}